setwd("C:/temp")
samplequantile_sqp2<-function(p){
  s<-p*(n+1)
  r<-floor(p*(n+1))
  alpha<-s-r
  Qp<-(1-alpha)*diff_sort[r]+alpha*diff_sort[r+1]
  return(Qp)
}

HD<-function(p){
  s1<-p*(n+1)
  s2<-(1-p)*(n+1)
  W1<-pbeta(c(1:n)/n, s1, s2)-pbeta((c(1:n)-1)/n,s1,s2)
  est<-t(W1)%*%diff_sort
  return(est)
}

SVp1<-function(p){
  first<-((2*dbinom(0,n,p)+dbinom(1,n,p))/2)*diff_sort[1]+(dbinom(0,n,p)/2)*diff_sort[2]-(dbinom(0,n,p)/2)*diff_sort[3]
  last<-(-dbinom(n,n,p)/2)*diff_sort[n-2]+(dbinom(n,n,p)/2)*diff_sort[n-1]+((2*dbinom(n,n,p)+dbinom((n-1),n,p))/2)*diff_sort[n]
  est<-sum(((dbinom((2:(n-1)),n,p)+dbinom(((2:(n-1))-1),n,p))/2)*diff_sort[(2:(n-1))])
  est<-first+est+last
  return(est)
}

#reading data from csv file
intradat<-read.csv("intra_example_data_set.csv", header=TRUE, sep=";")
head(intradat)
meas1<-intradat$meas1
meas2<-intradat$meas2

#Bland-Altman Limits of Agreement
diff<-meas1-meas2
meandif<-mean(diff)
standarddiv<-sd(diff)

BA_low<-meandif-1.96*standarddiv
BA_upp<-meandif+1.96*standarddiv

#sorting of differences
diff_sort<-sort(diff)

#number of observations
n<-length(diff)

#target quantiles
p<-0.025
q<-1-p

SQp2_low<-samplequantile_sqp2(p)
SQp2_upp<-samplequantile_sqp2(q)

HD_low<-HD(p)
HD_upp<-HD(q)

SVp1_low<-SVp1(p)
SVp1_upp<-SVp1(q)

#All estimates are printed
cat("BA LoA:",BA_low,"to",BA_upp,"\n","SQ2p: ",SQp2_low,"to",SQp2_upp,"\n","HD:   ",HD_low,"to",HD_upp,"\n","SVp1: ",SVp1_low,"to",SVp1_upp)
